Index: athstatic
===================================================================
--- athstatic	(revision 601a9e06d0bf114578e76e6fae7eed5d871c4a72)
+++ athstatic	(revision d09e5a1609d038695dbc6bc34a8177935a9bf7ea)
@@ -29,3 +29,4 @@
 done
 
+echo "$progname" $options
 exec "$progname" $options
Index: commands.c
===================================================================
--- commands.c	(revision ecd5dc5ca65a64da2e84de5dd1f997d246afd294)
+++ commands.c	(revision d09e5a1609d038695dbc6bc34a8177935a9bf7ea)
@@ -111,4 +111,9 @@
 	      "-O opcode\n"
 	      "      Send to the specified opcode\n"),
+
+  OWLCMD_ARGS("aimwrite", owl_command_aimwrite, OWL_CTX_INTERACTIVE,
+	      "send a zephyr",
+	      "aimzwrite <user>",
+	      "Send an aim message to a user.\n"),
 
   /*
@@ -566,4 +571,15 @@
 	      "is performed backwards"),
 
+  OWLCMD_ARGS("aimlogin", owl_command_aimlogin, OWL_CTX_ANY,
+	      "login to an AIM account",
+	      "aimlogin <screenname> <password>\n",
+	      ""),
+
+  OWLCMD_ARGS("aimlogout", owl_command_aimlogout, OWL_CTX_ANY,
+	      "logout from AIM",
+	      "aimlogout\n",
+	      ""),
+
+
   /****************************************************************/
   /************************* EDIT-SPECIFIC ************************/
@@ -1205,5 +1221,5 @@
     owl_function_xterm_deiconify();
   } else {
-    owl_function_makemsg("Uknown terminal subcommand");
+    owl_function_makemsg("Unknown terminal subcommand");
   }
   return(NULL);
@@ -1353,4 +1369,18 @@
     tmpbuff = owl_strdup(buff);
     owl_function_zwrite_setup(tmpbuff);
+    owl_global_set_buffercommand(&g, tmpbuff);
+    owl_free(tmpbuff);
+  }
+  return NULL;
+}
+
+char *owl_command_aimwrite(int argc, char **argv, char *buff) {
+  char *tmpbuff, *pos, *cmd, *msg;
+
+  if (argc < 2) {
+    owl_function_makemsg("Not enough arguments to the aimwrite command.");
+  } else {
+    tmpbuff = owl_strdup(buff);
+    owl_function_aimwrite_setup(tmpbuff);
     owl_global_set_buffercommand(&g, tmpbuff);
     owl_free(tmpbuff);
@@ -1740,4 +1770,26 @@
 }
 
+char *owl_command_aimlogin(int argc, char **argv, char *buff) {
+  int ret;
+
+  if (argc!=3) {
+    owl_function_makemsg("Wrong number of arguments to aimlogin command");
+    return(NULL);
+  }
+  ret=owl_aim_login(argv[1], argv[2]);
+  if (!ret) {
+    owl_function_makemsg("%s logged in.\n", argv[1]);
+    return(NULL);
+  }
+  
+  owl_function_makemsg("Warning: login for %s failed.\n");
+  return(NULL);
+}
+
+char *owl_command_aimlogout(int argc, char **argv, char *buff) {
+  owl_aim_logout();
+  return(NULL);
+}
+
 /*********************************************************************/
 /************************** EDIT SPECIFIC ****************************/
Index: configure.in
===================================================================
--- configure.in	(revision c269e22ca211d5bb3d7441f506b8bc00f49848a9)
+++ configure.in	(revision d09e5a1609d038695dbc6bc34a8177935a9bf7ea)
@@ -37,7 +37,8 @@
 AC_CHECK_LIB(des425, des425_req_act_vno)
 AC_CHECK_LIB(des, des_quad_cksum)
+AC_CHECK_LIB(resolv, res_search)
 AC_CHECK_LIB(krb5, krb5_get_credentials)
-AC_CHECK_LIB(krb4, krb_sendauth)
-AC_CHECK_LIB(krb, krb_sendauth)
+AC_CHECK_LIB(krb4, krb_sendauth,,
+   AC_CHECK_LIB(krb, krb_sendauth))
 AC_CHECK_LIB(zephyr, ZGetSender,, AC_MSG_ERROR(No zephyr library found.))
 AC_CHECK_LIB(zephyr, ZInitLocationInfo, AC_DEFINE([HAVE_LIBZEPHYR_ZINITLOCATIONINFO], [], [Have ZInitLocationInfo]),)
@@ -90,3 +91,5 @@
 AC_PROG_INSTALL
 
+AC_CONFIG_SUBDIRS(libfaim)
+
 AC_OUTPUT(Makefile)
Index: editwin.c
===================================================================
--- editwin.c	(revision 060b3b46a449e2dbac64a773d8c3d6c6c9e18642)
+++ editwin.c	(revision d09e5a1609d038695dbc6bc34a8177935a9bf7ea)
@@ -809,18 +809,4 @@
   }
   return(0);
-
-#if 0  /* old implementation */
-  if (e->bufflen>=2) {
-    if ((e->buff[e->bufflen-1]=='\n') &&
-	(e->buff[e->bufflen-2]=='.') &&
-	((e->bufflen==2) || (e->buff[e->bufflen-3]=='\n'))) {
-      e->buff[e->bufflen-2]='\0';
-      e->bufflen-=2;
-      owl_editwin_redisplay(e, 0);
-      return(1);
-    }
-  }
-  return(0);
-#endif
 }
 
Index: filter.c
===================================================================
--- filter.c	(revision 89426ab227853a484e0c7eee45362f0e6a80e5be)
+++ filter.c	(revision d09e5a1609d038695dbc6bc34a8177935a9bf7ea)
@@ -121,5 +121,5 @@
   char *field, *match;
 
-  /* create the working list */
+  /* create the working list of expression elements */
   fes=&(f->fes);
   owl_list_create(&work_fes);
@@ -129,5 +129,5 @@
   }
 
-  /* first go thru and turn all RE elements into true or false */
+  /* first go thru and evaluate all RE elements to true or false */
   match="";
   for (i=0; i<j; i++) {
@@ -152,4 +152,6 @@
       if (owl_message_is_type_zephyr(m)) {
 	match="zephyr";
+      } else if (owl_message_is_type_aim(m)) {
+	match="aim";
       } else if (owl_message_is_type_admin(m)) {
 	match="admin";
@@ -177,10 +179,9 @@
   }
 
-  
   /* call the recrsive helper */
   i=_owl_filter_message_match_recurse(f, m, &work_fes, 0, owl_list_get_size(&(f->fes))-1);
 
+  /* now there will be only one TRUE / FALSE, find it among the NULL's */
   tmp=0;
-  /* now we should have one value */
   for (i=0; i<j; i++) {
     fe=owl_list_get_element(&work_fes, i);
@@ -196,7 +197,7 @@
   }  
 
-  if (f->polarity) {
-    tmp=!tmp;
-  }
+  /* reverse the answer if negative polarity is in use */
+  if (f->polarity) tmp=!tmp;
+
   owl_list_free_simple(&work_fes);
   return(tmp);
@@ -207,6 +208,7 @@
   owl_filterelement *fe, *tmpfe=NULL;
 
-  /* deal with parens first */
+  /* Deal with parens first. */
   for (i=0; i<OWL_FILTER_MAX_DEPTH; i++) {
+    /* Find first open paren and matching close paren, store in x, y */
     score=x=y=0;
     for (i=start; i<=end; i++) {
@@ -231,4 +233,5 @@
     }
 
+    /* Simply the parens by removing them and evaluating what was in between */
     if (y>0) {
       /* null out the parens */
@@ -236,5 +239,5 @@
       owl_list_replace_element(fes, y, owl_global_get_filterelement_null(&g));
 
-      /* simplify the part that was in between */
+      /* evaluate expression in between */
       ret=_owl_filter_message_match_recurse(f, m, fes, x+1, y-1);
       if (ret<0) return(-1);
@@ -248,8 +251,17 @@
   }
   if (i==OWL_FILTER_MAX_DEPTH) {
+    /* hit the saftey limit, consider it invalid */
     return(-1);
   }
 
-  /* and / or / not */
+  /* Find AND / OR / NOT.
+   *   For binary expressions (AND/OR):
+   *     "type" is 1
+   *     "x" will index first val, "y" the operator and "z" the second val
+   *   For unary expressions (NOT):
+   *     "type" is 2
+   *     "x" will index the operator, "y" the value
+   *   "score" tallys how many expression elements have been found so far
+   */
   for (i=0; i<OWL_FILTER_MAX_DEPTH; i++) {
     type=score=x=y=z=0;
@@ -273,9 +285,10 @@
 	    y=i;
 	  } else {
+	    /* it's not a valid binary expression */
 	    x=y=z=score=0;
 	  }
 	} else if (type==2) {
 	  if (owl_filterelement_is_value(fe)) {
-	    /* it's a valid "NOT expr" */
+	    /* valid unary expression, we're done */
 	    y=i;
 	    break;
@@ -284,5 +297,5 @@
       } else if (score==2) {
 	if (owl_filterelement_is_value(fe)) {
-	  /* yes, it's a good match */
+	  /* valid binary expression, we're done */
 	  z=i;
 	  break;
@@ -293,5 +306,5 @@
     }
 
-    /* process and / or */
+    /* simplify AND / OR */
     if ((type==1) && (z>0)) {
       fe=owl_list_get_element(fes, x);
@@ -326,5 +339,6 @@
       owl_list_replace_element(fes, y, tmpfe);
       owl_list_replace_element(fes, z, owl_global_get_filterelement_null(&g));
-    } else if ((type==2) && (y>0)) { /* process NOT */
+    } else if ((type==2) && (y>0)) {
+      /* simplify NOT */
       fe=owl_list_get_element(fes, y);
       owl_list_replace_element(fes, x, owl_global_get_filterelement_null(&g));
Index: functions.c
===================================================================
--- functions.c	(revision 801c7cb7accba902624ed78dcf2d2fa4c7310d69)
+++ functions.c	(revision d09e5a1609d038695dbc6bc34a8177935a9bf7ea)
@@ -10,4 +10,5 @@
 #include <sys/wait.h>
 #include <errno.h>
+#include <signal.h>
 #include "owl.h"
 
@@ -124,4 +125,32 @@
 }
 
+void owl_function_make_outgoing_aim(char *body, char *to)
+{
+  owl_message *m;
+  int followlast;
+  
+  followlast=owl_global_should_followlast(&g);
+
+  /* create the message */
+  m=owl_malloc(sizeof(owl_message));
+  owl_message_create_aim(m, owl_global_get_aim_screenname(&g), body);
+  owl_message_set_recipient(m, to);
+  owl_message_set_direction_out(m);
+
+  /* add it to the global list and current view */
+  owl_messagelist_append_element(owl_global_get_msglist(&g), m);
+  owl_view_consider_message(owl_global_get_current_view(&g), m);
+
+  if (followlast) owl_function_lastmsg_noredisplay();
+
+  owl_mainwin_redisplay(owl_global_get_mainwin(&g));
+  if (owl_popwin_is_active(owl_global_get_popwin(&g))) {
+    owl_popwin_refresh(owl_global_get_popwin(&g));
+  }
+  
+  wnoutrefresh(owl_global_get_curs_recwin(&g));
+  owl_global_set_needrefresh(&g);
+}
+
 void owl_function_zwrite_setup(char *line)
 {
@@ -166,4 +195,34 @@
 }
 
+void owl_function_aimwrite_setup(char *line)
+{
+  owl_editwin *e;
+  char buff[1024];
+
+  /* check the arguments */
+
+  /* create and setup the editwin */
+  e=owl_global_get_typwin(&g);
+  owl_editwin_new_style(e, OWL_EDITWIN_STYLE_MULTILINE, owl_global_get_msg_history(&g));
+
+  if (!owl_global_get_lockout_ctrld(&g)) {
+    owl_function_makemsg("Type your message below.  End with ^D or a dot on a line by itself.  ^C will quit.");
+  } else {
+    owl_function_makemsg("Type your message below.  End with a dot on a line by itself.  ^C will quit.");
+  }
+
+  owl_editwin_clear(e);
+  owl_editwin_set_dotsend(e);
+  strcpy(buff, "----> ");
+  strcat(buff, line);
+  strcat(buff, "\n");
+  owl_editwin_set_locktext(e, buff);
+
+  /* make it active */
+  owl_global_set_typwin_active(&g);
+}
+
+
+
 void owl_function_zcrypt_setup(char *line)
 {
@@ -241,4 +300,26 @@
   owl_zwrite_free(&z);
 }
+
+
+void owl_function_aimwrite(char *to)
+{
+  /*  send the message */
+  owl_aim_send_im(to, owl_editwin_get_text(owl_global_get_typwin(&g)));
+  owl_function_makemsg("AIM message sent.");
+
+  /* display the message as an outgoing message in the receive window */
+  if (owl_global_is_displayoutgoing(&g)) {
+    owl_function_make_outgoing_aim(owl_editwin_get_text(owl_global_get_typwin(&g)), to);
+  }
+
+  /* not yet */
+#if 0
+  /* log it if we have logging turned on */
+  if (owl_global_is_logging(&g)) {
+    owl_log_outgoing(to, owl_editwin_get_text(owl_global_get_typwin(&g)));
+  }
+#endif
+}
+
 
 
@@ -619,4 +700,9 @@
   ret = owl_config_execute("owl::shutdown();");
   if (ret) owl_free(ret);
+
+  /* signal our child process, if any */
+  if (owl_global_get_newmsgproc_pid(&g)) {
+    kill(owl_global_get_newmsgproc_pid(&g), SIGHUP);
+  }
 
   /* final clean up */
@@ -1005,6 +1091,7 @@
   buff=owl_global_get_buffercommand(&g);
   if (!strncmp(buff, "zwrite ", 7)) {
-
     owl_function_zwrite(buff);
+  } else if (!strncmp(buff, "aimwrite ", 9)) {
+    owl_function_aimwrite(buff+9);
   }
 }
@@ -1193,4 +1280,6 @@
   } else if (owl_message_is_type_generic(m)) {
     owl_fmtext_append_normal(&fm, "Type      : generic\n");
+  } else if (owl_message_is_type_aim(m)) {
+    owl_fmtext_append_normal(&fm, "Type      : aim\n");
   } else {
     owl_fmtext_append_normal(&fm, "Type      : unknown\n");
@@ -1680,17 +1769,25 @@
     }
 
-    /* for now we disable replies to zcrypt messages, since we can't
-       support an encrypted reply */
-    if (!strcasecmp(owl_message_get_opcode(m), "crypt")) {
-      owl_function_makemsg("Replies to zcrypt messages are not enabled in this release");
+    /* admin */
+    if (owl_message_is_type_admin(m)) {
+      owl_function_makemsg("You cannot reply to an admin message");
       return;
     }
 
-    if (owl_message_is_direction_out(m)) {
-      owl_function_zwrite_setup(owl_message_get_zwriteline(m));
-      owl_global_set_buffercommand(&g, owl_message_get_zwriteline(m));
-    } else if (owl_message_is_type_admin(m)) {
-      owl_function_makemsg("You cannot reply to an admin message");
-    } else {
+    /* zephyr */
+    if (owl_message_is_type_zephyr(m)) {
+      /* for now we disable replies to zcrypt messages, since we can't
+	 support an encrypted reply */
+      if (!strcasecmp(owl_message_get_opcode(m), "crypt")) {
+	owl_function_makemsg("Replies to zcrypt messages are not enabled in this release");
+	return;
+      }
+
+      if (owl_message_is_direction_out(m)) {
+	owl_function_zwrite_setup(owl_message_get_zwriteline(m));
+	owl_global_set_buffercommand(&g, owl_message_get_zwriteline(m));
+	return;
+      }
+      
       if (owl_message_is_login(m)) {
 	class="MESSAGE";
@@ -1714,5 +1811,5 @@
 	}
       }
-      
+	
       /* create the command line */
       buff = owl_strdup("zwrite");
@@ -1745,15 +1842,20 @@
       }
       if (cc) owl_free(cc);
-
-      if (enter) {
-	owl_history *hist = owl_global_get_cmd_history(&g);
-	owl_history_store(hist, buff);
-	owl_history_reset(hist);
-	owl_function_command_norv(buff);
-      } else {
-	owl_function_start_command(buff);
-      }
-      owl_free(buff);
-    }
+    }
+
+    /* aim */
+    if (owl_message_is_type_aim(m)) {
+      buff=owl_sprintf("aimwrite %s", owl_message_get_sender(m));
+    }
+
+    if (enter) {
+      owl_history *hist = owl_global_get_cmd_history(&g);
+      owl_history_store(hist, buff);
+      owl_history_reset(hist);
+      owl_function_command_norv(buff);
+    } else {
+      owl_function_start_command(buff);
+    }
+    owl_free(buff);
   }
 }
Index: global.c
===================================================================
--- global.c	(revision ecd5dc5ca65a64da2e84de5dd1f997d246afd294)
+++ global.c	(revision d09e5a1609d038695dbc6bc34a8177935a9bf7ea)
@@ -51,4 +51,5 @@
   owl_list_create(&(g->filterlist));
   owl_list_create(&(g->puntlist));
+  owl_list_create(&(g->messagequeue));
   g->curmsg_vert_offset=0;
   g->resizepending=0;
@@ -87,4 +88,8 @@
   owl_mainwin_init(&(g->mw));
   owl_popwin_init(&(g->pw));
+
+  g->aim_screenname=NULL;
+  g->aim_loggedin=0;
+  g->aim_lastnop=0;
 }
 
@@ -637,2 +642,77 @@
   return(g->malloced-g->freed);
 }
+
+/* AIM stuff */
+
+int owl_global_is_aimloggedin(owl_global *g) {
+  if (g->aim_loggedin) return(1);
+  return(0);
+}
+
+char *owl_global_get_aim_screenname(owl_global *g) {
+  return (g->aim_screenname);
+}
+
+void owl_global_set_aimloggedin(owl_global *g, char *screenname) {
+  g->aim_loggedin=1;
+  if (g->aim_screenname) owl_free(g->aim_screenname);
+  g->aim_screenname=owl_strdup(screenname);
+}
+
+void owl_global_set_aimnologgedin(owl_global *g) {
+  g->aim_loggedin=0;
+}
+
+aim_session_t *owl_global_get_aimsess(owl_global *g) {
+  return(&(g->aimsess));
+}
+
+aim_conn_t *owl_global_get_waitingconn(owl_global *g) {
+  return(&(g->waitingconn));
+}
+
+int owl_global_is_aimnop_time(owl_global *g) {
+  time_t now;
+
+  now=time(NULL);
+  if (g->aim_lastnop==0) {
+    g->aim_lastnop=now;
+    return(0);
+  }
+
+  if (now-g->aim_lastnop >= 30) {
+    return(1);
+  }
+  return(0);
+}
+
+void owl_global_aimnop_sent(owl_global *g) {
+  time_t now;
+
+  now=time(NULL);
+  g->aim_lastnop=now;
+}
+
+/* message queue */
+
+void owl_global_messagequeue_addmsg(owl_global *g, owl_message *m) {
+  owl_list_append_element(&(g->messagequeue), m);
+}
+
+/* pop off the first message and return it.  Return NULL if the queue
+ * is empty.  The caller should free the message after using it, if
+ * necessary.
+ */
+owl_message *owl_global_messageuque_popmsg(owl_global *g) {
+  owl_message *out;
+
+  if (owl_list_get_size(&(g->messagequeue))==0) return(NULL);
+  out=owl_list_get_element(&(g->messagequeue), 0);
+  owl_list_remove_element(&(g->messagequeue), 0);
+  return(out);
+}
+
+int owl_global_messagequeue_pending(owl_global *g) {
+  if (owl_list_get_size(&(g->messagequeue))==0) return(0);
+  return(1);
+}
Index: list.c
===================================================================
--- list.c	(revision 1aee7d914de75510e7cf09c452bad63b2dad2166)
+++ list.c	(revision d09e5a1609d038695dbc6bc34a8177935a9bf7ea)
@@ -26,8 +26,11 @@
 
 int owl_list_append_element(owl_list *l, void *element) {
+  void *ptr;
+  
   if ((l->size+1) > (l->avail/GROWAT)) {
-    l->list=owl_realloc(l->list, l->avail*GROWBY*sizeof(void *));
+    ptr=owl_realloc(l->list, l->avail*GROWBY*sizeof(void *));
+    if (ptr==NULL) return(-1);
+    l->list=ptr;
     l->avail=l->avail*GROWBY;
-    if (l->list==NULL) return(-1);
   }
 
@@ -38,10 +41,12 @@
 
 int owl_list_prepend_element(owl_list *l, void *element) {
+  void *ptr;
   int i;
  
   if ((l->size+1) > (l->avail/GROWAT)) {
-    l->list=owl_realloc(l->list, l->avail*GROWBY*sizeof(void *));
+    ptr=owl_realloc(l->list, l->avail*GROWBY*sizeof(void *));
+    if (ptr==NULL) return(-1);
+    l->list=ptr;
     l->avail=l->avail*GROWBY;
-    if (l->list==NULL) return(-1);
   }
 
Index: logging.c
===================================================================
--- logging.c	(revision 4b464a43720ec7191ae97a55c10c3e66721ed93f)
+++ logging.c	(revision d09e5a1609d038695dbc6bc34a8177935a9bf7ea)
@@ -60,4 +60,7 @@
   int len, ch, i, personal;
 
+  /* we only do zephyrs right now */
+  if (!owl_message_is_type_zephyr(m)) return;
+      
   /* check for nolog */
   if (!strcasecmp(owl_message_get_opcode(m), "nolog") ||
Index: message.c
===================================================================
--- message.c	(revision c86a35c5566beb47fb2bb90015beb6055536aff8)
+++ message.c	(revision d09e5a1609d038695dbc6bc34a8177935a9bf7ea)
@@ -196,4 +196,8 @@
   m->type=OWL_MESSAGE_TYPE_ZEPHYR;
 }
+
+void owl_message_set_type_aim(owl_message *m) {
+  m->type=OWL_MESSAGE_TYPE_AIM;
+}
 						
 int owl_message_is_type_admin(owl_message *m) {
@@ -204,4 +208,9 @@
 int owl_message_is_type_zephyr(owl_message *m) {
   if (m->type==OWL_MESSAGE_TYPE_ZEPHYR) return(1);
+  return(0);
+}
+
+int owl_message_is_type_aim(owl_message *m) {
+  if (m->type==OWL_MESSAGE_TYPE_AIM) return(1);
   return(0);
 }
@@ -384,5 +393,4 @@
 
   owl_message_init(m);
-
   owl_message_set_body(m, text);
 
@@ -398,4 +406,27 @@
   }
 
+  owl_free(indent);
+}
+
+void owl_message_create_aim(owl_message *m, char *sender, char *text) {
+  char *indent;
+
+  owl_message_init(m);
+  owl_message_set_body(m, text);
+  owl_message_set_sender(m, sender);
+  owl_message_set_type_aim(m);
+
+  indent=owl_malloc(strlen(text)+owl_text_num_lines(text)*OWL_MSGTAB+10);
+  owl_text_indent(indent, text, OWL_MSGTAB);
+  owl_fmtext_init_null(&(m->fmtext));
+  owl_fmtext_append_normal(&(m->fmtext), OWL_TABSTR);
+  owl_fmtext_append_normal(&(m->fmtext), "AIM: ");
+  owl_fmtext_append_normal(&(m->fmtext), sender);
+  owl_fmtext_append_normal(&(m->fmtext), "\n");
+  owl_fmtext_append_ztext(&(m->fmtext), indent);
+  if (text[strlen(text)-1]!='\n') {
+    owl_fmtext_append_normal(&(m->fmtext), "\n");
+  }
+  
   owl_free(indent);
 }
Index: owl.c
===================================================================
--- owl.c	(revision ac70242984535359cfe3077777a7067de6dfef19)
+++ owl.c	(revision d09e5a1609d038695dbc6bc34a8177935a9bf7ea)
@@ -31,5 +31,5 @@
   owl_popwin *pw;
   int j, ret, initialsubs, debug, argcsave, followlast;
-  int newzephyrs, zpendcount, nexttimediff;
+  int newmsgs, zpendcount, nexttimediff;
   struct sigaction sigact;
   char *configfile, *tty, *perlout, **argvsave, buff[LINE], startupmsg[LINE];
@@ -214,4 +214,7 @@
     owl_function_zlog_in();
   }
+
+  /* AIM init */
+  owl_aim_init();
 
   /* welcome message */
@@ -264,7 +267,7 @@
 
     /* grab incoming zephyrs */
-    newzephyrs=0;
+    newmsgs=0;
     zpendcount=0;
-    while(ZPending()) {
+    while(ZPending() || owl_global_messagequeue_pending(&g)) {
       ZNotice_t notice;
       struct sockaddr_in from;
@@ -272,24 +275,28 @@
       owl_filter *f;
 
-      /* grab a notice, but if we've done 20 without stopping, take
-	 a break to process keystrokes etc. */
-      if (zpendcount>20) break;
-      ZReceiveNotice(&notice, &from);
-      zpendcount++;
-
-      /* is this an ack from a zephyr we sent? */
-      if (owl_zephyr_notice_is_ack(&notice)) {
-	owl_zephyr_handle_ack(&notice);
-	continue;
-      }
-      
-      /* if it's a ping and we're not viewing pings then skip it */
-      if (!owl_global_is_rxping(&g) && !strcasecmp(notice.z_opcode, "ping")) {
-	continue;
-      }
-
-      /* create the new message */
-      m=owl_malloc(sizeof(owl_message));
-      owl_message_create_from_znotice(m, &notice);
+      if (ZPending()) {
+	/* grab a zephyr notice, but if we've done 20 without stopping,
+	   take a break to process keystrokes etc. */
+	if (zpendcount>20) break;
+	ZReceiveNotice(&notice, &from);
+	zpendcount++;
+	
+	/* is this an ack from a zephyr we sent? */
+	if (owl_zephyr_notice_is_ack(&notice)) {
+	  owl_zephyr_handle_ack(&notice);
+	  continue;
+	}
+	
+	/* if it's a ping and we're not viewing pings then skip it */
+	if (!owl_global_is_rxping(&g) && !strcasecmp(notice.z_opcode, "ping")) {
+	  continue;
+	}
+
+	/* create the new message */
+	m=owl_malloc(sizeof(owl_message));
+	owl_message_create_from_znotice(m, &notice);
+      } else if (owl_global_messagequeue_pending(&g)) {
+	m=owl_global_messageuque_popmsg(&g);
+      }
       
       /* if it's on the puntlist then, nuke it and continue */
@@ -301,5 +308,5 @@
       /* otherwise add it to the global list */
       owl_messagelist_append_element(owl_global_get_msglist(&g), m);
-      newzephyrs=1;
+      newmsgs=1;
 
       /* let the config know the new message has been received */
@@ -324,6 +331,4 @@
 	owl_function_command(owl_global_get_alert_action(&g));
       }
-
-	 
 
       /* check for burning ears message */
@@ -338,5 +343,5 @@
       }
 
-      /* log the zephyr if we need to */
+      /* log the message if we need to */
       if (owl_global_is_logging(&g) || owl_global_is_classlogging(&g)) {
 	owl_log_incoming(m);
@@ -344,18 +349,23 @@
     }
 
+    /* If we're logged into AIM, do AIM stuff */
+    if (owl_global_is_aimloggedin(&g)) {
+      owl_function_debugmsg("Doing aim processing");
+      owl_aim_process_events();
+    }
+
     /* follow the last message if we're supposed to */
-    if (newzephyrs && followlast) {
+    if (newmsgs && followlast) {
       owl_function_lastmsg_noredisplay();
     }
 
     /* do the newmsgproc thing */
-    if (newzephyrs) {
+    if (newmsgs) {
       owl_function_do_newmsgproc();
     }
     
     /* redisplay if necessary */
-    /* maybe this should be optimized to not even run if
-       the zephyr won't be displayed */
-    if (newzephyrs) {
+    /* this should be optimized to not run if the new messages won't be displayed */
+    if (newmsgs) {
       owl_mainwin_redisplay(owl_global_get_mainwin(&g));
       sepbar(NULL);
@@ -394,5 +404,8 @@
     }
 
-    /* handle all keypresses */
+    /* Handle all keypresses.
+     * If no key has been pressed sleep for a little bit, but
+     * otherwise do not, this lets input be grabbed as quickly
+     * as possbile */
     j=wgetch(typwin);
     if (j==ERR) {
@@ -426,5 +439,4 @@
     }
   }
-
 }
 
Index: owl.h
===================================================================
--- owl.h	(revision c86a35c5566beb47fb2bb90015beb6055536aff8)
+++ owl.h	(revision d09e5a1609d038695dbc6bc34a8177935a9bf7ea)
@@ -8,4 +8,6 @@
 #include <netdb.h>
 #include <regex.h>
+#include <time.h>
+#include <libfaim/aim.h>
 #include "config.h"
 
@@ -396,4 +398,10 @@
   owl_filterelement fe_false;
   owl_filterelement fe_null;
+  aim_session_t aimsess;
+  aim_conn_t waitingconn;
+  time_t aim_lastnop;
+  int aim_loggedin;
+  char *aim_screenname;
+  owl_list messagequeue; /* for queueing up aim and other messages */
 } owl_global;
 
